//********************************************************************** 
/*
	J[ZT[̂qfaf[^\
*/
//********************************************************************** 

#define		GATE		PORTA.F2
#define		CK			PORTA.F3
#define		RANGE		PORTA.F4
#define		DOUT		PORTA.F5

#define		RANGE_SW	PORTB.F4

//********************************************************************** 

void	GetColor(short sensitivity, int addTime, int* pColor)
{
	static	unsigned	int		RED, GREEN, BLUE, tmp;
	static	unsigned	short	cnt;
	//
	GATE = 0;
	CK = 0;
	RANGE = sensitivity;
	GATE = 1;
	for (; addTime > 0; addTime--) {
		Delay_ms(1);
	}
	GATE = 0;
	//ԐFf[^̎荞 
	RED = 0;
	for (cnt = 0; cnt < 12; cnt++) {
		CK = 1;
		CK = 0;
		tmp = DOUT << cnt;
		RED |= tmp;
	}
	*pColor = RED;
	pColor++;
	//ΐFf[^̎荞 
	GREEN = 0;
	for (cnt = 0; cnt < 12; cnt++) {
		CK = 1;
		CK = 0;
		tmp = DOUT << cnt;
		GREEN |= tmp;
	}
	*pColor = GREEN;
	pColor++;
	//Ff[^̎荞 
	BLUE = 0;
	for (cnt = 0; cnt < 12; cnt++) {
		CK = 1;
		CK = 0;
		tmp = DOUT << cnt;
		BLUE |= tmp;
	}
	*pColor = BLUE;
}

//********************************************************************** 

void main()
{
	//ϐ̐ݒ 
	static	unsigned	char	buf[10];
	static	unsigned	short	cnt;
	static	unsigned	int		color[3];
	//|[g֘A̐ݒ 
	TRISA = 0b00100000;
	TRISB = 0b00010000;
	OSCCON = 0b01110000;	// NbN8Mhzɐݒ肷B 
	ANSEL = 0b00000000;		// `^cϊ͎gpȂB
	//LCD̐ݒ 
	Lcd_Custom_Config(&PORTA, 1, 0, 7, 6, &PORTB, 5, 6, 7);
	Lcd_Custom_Cmd(LCD_CURSOR_OFF);
	Lcd_Custom_Cmd(LCD_CLEAR);
	//
	while (1) {
		//J[f[^̎擾 
		GetColor(RANGE_SW, 1000, color);
		//ԐFf[^\ 
		WordToStr(color[0], buf);
		Lcd_Custom_Out(1, 1, "R:");
		Lcd_Custom_Out(1, 3, &buf[1]);
		//΃f[^\ 
		WordToStr(color[1], buf);
		Lcd_Custom_Out(1, 9, "G:");
		Lcd_Custom_Out(1, 11, &buf[1]);
		//Ff[^\ 
		WordToStr(color[2], buf);
		Lcd_Custom_Out(2, 1, "B:");
		Lcd_Custom_Out(2, 3, &buf[1]);
	}
}

//********************************************************************** 
